## nodejs 18.7.0+dfsg

=== deps/openssl/config/Makefile ===
# This Makefile is confirmed to be run only on Linux (CentOS and
# Ubuntu). perl5 and gas(>=2.26) are needed.

UNAME_S := $(shell uname -s)
ifneq ($(UNAME_S),Linux)
  $(error This can be run only on Linux)
endif

PERL    = perl

# Supported architecture list
ASM_ARCHS = aix64-gcc-as BSD-x86 BSD-x86_64 \
darwin64-x86_64-cc darwin-i386-cc darwin64-arm64-cc linux-aarch64 \
linux-armv4 linux-elf linux-x86_64 \
linux-ppc64le linux32-s390x linux64-s390x linux64-mips64\
solaris-x86-gcc solaris64-x86_64-gcc VC-WIN64A VC-WIN32

NO_ASM_ARCHS = VC-WIN64-ARM linux64-riscv64

CC = gcc
FAKE_GCC = ../config/fake_gcc.pl

CONFIGURE = ./Configure
# no-comp: against CRIME attack
# no-shared: openssl-cli needs static link
# no-afalgeng: old Linux kernel < 4.0 does not support it
# enable-ssl-trace: cause the optional SSL_trace API to be built
COPTS =  no-comp no-shared no-afalgeng enable-ssl-trace enable-fips

# disable platform check in Configure
NO_WARN_ENV = CONFIGURE_CHECKER_WARN=1

GENERATE = ./generate_gypi.pl

OPSSL_SRC = ../openssl

# Header files generated with Configure
#INT_CFGS = bn_conf.h dso_conf.h
INT_CFG_DIR = $(OPSSL_SRC)/include/crypto
GEN_HEADERS = asn1 asn1t bio cmp cms configuration conf crmf crypto ct err    \
              ess fipskey lhash ocsp opensslv pkcs12 pkcs7 safestack srp ssl  \
	      ui x509 x509v3 x509_vfy conf

CRYPTO_GEN_HEADERS = bn_conf dso_conf

PHONY = all clean replace generate_headers
.PHONY: $(PHONY)

#all: $(ASM_ARCHS) $(NO_ASM_ARCHS) generate_headers replace
all: $(ASM_ARCHS) $(NO_ASM_ARCHS) generate_headers

# Configure and generate openssl asm files for each archs
$(ASM_ARCHS):
	cd $(OPSSL_SRC); $(NO_WARN_ENV) CC=$(CC) $(PERL) $(CONFIGURE) $(COPTS) $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) asm $@ "${GEN_HEADERS}" "${CRYPTO_GEN_HEADERS}"
# Confgure asm_avx2 and generate upto avx2 support
	cd $(OPSSL_SRC); $(NO_WARN_ENV) CC=$(FAKE_GCC) $(PERL) $(CONFIGURE) \
	$(COPTS) $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) asm_avx2 $@ "${GEN_HEADERS}" "${CRYTO_GEN_HEADERS}"
# Configure no-asm and generate no-asm sources
	cd $(OPSSL_SRC); $(NO_WARN_ENV) $(PERL) $(CONFIGURE) $(COPTS) \
	no-asm $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) no-asm $@ "${GEN_HEADERS}" "${CRYPTO_GEN_HEADERS}"

$(NO_ASM_ARCHS):
# Configure no-asm and generate no-asm sources
	cd $(OPSSL_SRC); $(NO_WARN_ENV) $(PERL) $(CONFIGURE) $(COPTS) \
	no-asm $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) no-asm $@ "${GEN_HEADERS}" "${CRYPTO_GEN_HEADERS}"

generate_headers:
	@$(PERL) -w -I$(OPSSL_SRC) ./generate_headers.pl "${GEN_HEADERS}" "${CRYPTO_GEN_HEADERS}"

clean:
	find archs \( -name \*.S -o -name \*.s -o -name \*.asm -o \
	-name \*.gypi -o -name \*.h -o -name \*.pm -o -name \*.rc \) -exec rm "{}" \;

=== debian/changelog ===
nodejs (18.7.0+dfsg-5) unstable; urgency=medium

  * Tighten dependency with armv6k-support

 -- Jérémy Lal <kapouer@melix.org>  Thu, 01 Sep 2022 18:33:49 +0200

nodejs (18.7.0+dfsg-4) unstable; urgency=medium

  * lintian overrides:
    + fix embedded-library zlib
    + slightly more info about source-is-missing  
  * copyright: fix license short name for base64

 -- Jérémy Lal <kapouer@melix.org>  Tue, 30 Aug 2022 15:52:53 +0200

nodejs (18.7.0+dfsg-3) unstable; urgency=medium

  * Rename and DEP-3 latest armel patch
  * Restore build using gcc 11,
    it was removed by mistake in the previous upload

 -- Jérémy Lal <kapouer@melix.org>  Mon, 29 Aug 2022 17:03:45 +0200

nodejs (18.7.0+dfsg-2) unstable; urgency=medium

  * Build on armel where armv6k, vfpv2 is supported:
    + control: add Architecture: armel
    + control: depends armv6-support:armel, vfpv2-support:armel
    + rules: set -march=armv6k
    + patch: add --with-arm-version configure.py flag

 -- Jérémy Lal <kapouer@melix.org>  Mon, 29 Aug 2022 00:09:15 +0200

nodejs (18.7.0+dfsg-1) unstable; urgency=medium

  * New upstream version 18.7.0+dfsg
  * Update flaky riscv64: sequential/test-cpu-prof-drained.
    Closes: #1016707.
  * copyright: deps/base64 BSD-2-clause

 -- Jérémy Lal <kapouer@melix.org>  Fri, 12 Aug 2022 17:21:50 +0200

nodejs (18.6.0+dfsg-5) unstable; urgency=medium

  * Build-Depends gcc-11, g++-11.
    Allow transition while waiting for #1016628 to be sorted out.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 04 Aug 2022 17:32:43 +0200

nodejs (18.6.0+dfsg-4) unstable; urgency=medium

  * Patches: Closes: #1016305
    + upstream fix getaddrinfo without network
    + fix test failing with libuv1 >= 1.44.2
  * Patch: upstream fix ppc64 crash with regexp. Closes: #1016381.
  * Drop RES_OPTIONS to avoid test failures with localhost

 -- Jérémy Lal <kapouer@melix.org>  Mon, 01 Aug 2022 22:37:57 +0200

nodejs (18.6.0+dfsg-3) unstable; urgency=medium

  * Patch: add sequential/test-worker-prof to failing riscv64 tests

 -- Jérémy Lal <kapouer@melix.org>  Mon, 18 Jul 2022 23:22:08 +0200

nodejs (18.6.0+dfsg-2) experimental; urgency=medium

  * Fix path where to look for @types/node
    when fixing permissions.
    Also use execute_after_dh_fixperms.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 16 Jul 2022 17:38:26 +0200

nodejs (18.6.0+dfsg-1) experimental; urgency=medium

  * New upstream version 18.6.0+dfsg
  * Patches:
    + work around IPv6 getaddrinfo EAI_AGAIN localhost failure
      with some tests on zandonai
    + reenable global fetch and its tests
  * Build-Depends node-undici
  * Bump Standards-Version, no change
  * Fix @types/node permissions
  * lintian overrides:
    + drop unneeded libnode108 lines
    + update to new format
    + ignore source-is-missing for regenerated doc
  * copyright:
    + tools/rpm/ no longer here
    + fix order of paragraphs
    + fix wildcard
    + remove useless Licenses

 -- Jérémy Lal <kapouer@melix.org>  Sat, 16 Jul 2022 15:35:17 +0200

nodejs (18.4.0+dfsg-2) experimental; urgency=medium

  * Breaks libnode72 << 13 because of bullseye/security
    (Closes: #1013968)
  * Fix bash-completion link (Closes: #977792)
  * Patch: disable fetch until undici is accepted (Closes: #1014214)

 -- Jérémy Lal <kapouer@melix.org>  Mon, 04 Jul 2022 11:37:13 +0200

nodejs (18.4.0+dfsg-1) experimental; urgency=medium

  * New upstream version 18.4.0+dfsg
  * lintian-overrides:
    + drop node-acorn/*, no longer a component
    + improve embedded-library zlib and comment it
  * copyright:
    + remove useless files and paragraphs
    + fix order of paragraphs
  * patches:
    + remove very old unapplied files
    + fix non-utf8 encoding in one patch
    + fix mipsel compilation failure
  * unidici missing: do not crash, just have no exports
  * postpone usr/include/nodejs renaming, do it
    in libnode-dev.files.
  * Fix badly reverted usr/include/nodejs rename:
    /usr/include/node is for n-api, nodejs for old addons
  * hardening flags: -pie is no longer needed

 -- Jérémy Lal <kapouer@melix.org>  Tue, 21 Jun 2022 21:14:28 +0200

nodejs (18.3.0+dfsg-1) experimental; urgency=medium

  * New upstream version 18.3.0+dfsg
  * Follow upstream make install:
    + let node install its own headers
    + keep a symlink to /usr/include/nodejs,
      will be removed when node-gyp is updated
  * watch latest version
  * gbp on master
  * Add noautodbgsym to README.source profiles
  * Clean debian/nodejs.bash-completion
  * Drop openssl-cnf.patch, upstream use openssl 3
  * Skip another test using undici
  * Bump libnode abi

 -- Jérémy Lal <kapouer@melix.org>  Tue, 14 Jun 2022 10:40:33 +0200

nodejs (16.15.1+dfsg-1) unstable; urgency=medium

  * New upstream version 16.15.1+dfsg
  * Fix completion generation, support "nodejs" cli
    Closes: #977792
  * Patch to fix mipsel crypto init error strings (Closes: #1011101)
  * Patch: more flaky riscv64 cpu tests (Closes: #1012670)

 -- Jérémy Lal <kapouer@melix.org>  Mon, 13 Jun 2022 09:11:34 +0200

nodejs (16.15.0+dfsg-1) unstable; urgency=medium

  * New upstream version 16.15.0+dfsg
  * Go back to +dfsg
  * dfsg-exclude undici (missing source for compiled wasm)
  * Will B-D undici <!pkg.nodejs.nobuiltin> when available
  * bash-completion from node --completion-bash (Closes: #977792)
  * Patches:
    + build/skip-crypto-engine-check no longer needed
    + test-diagnostic-dir-cpu-prof is flaky on riscv64
      (Closes: #1011100)
  * Update README.source
  * Fix undici source name
  * Update openssl.cnf to fix tests on mipsel (Closes: #1011339)
  * Improve doc-generator

 -- Jérémy Lal <kapouer@melix.org>  Fri, 27 May 2022 15:48:16 +0200

=== debian/control ===
Source: nodejs
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@alioth-lists.debian.net>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends:
 gcc-11, g++-11,
 sse2-support [i386] <!nocheck>,
 armv6k-support [armel] <!nocheck>, vfpv2-support [armel] <!nocheck>,
 debhelper-compat (= 13),
 dh-buildinfo,
 bash-completion,
 ca-certificates,
 curl <!nocheck>,
 gyp (>= 0.1~svn1773),
 jq,
 libbrotli-dev,
 libbrotli-dev:native,
 libc-ares-dev (>= 1.18.1~),
 libc-ares-dev:native,
 libhttp-parser-dev (>= 2.9.2~),
 libicu-dev (>= 70.1~),
 libicu-dev:native,
 libkvm-dev [kfreebsd-any],
 libnghttp2-dev (>= 1.41.0~),
 libnghttp2-dev:native,
 libssl-dev (>= 1.1.1~),
 libssl-dev:native,
 libuv1-dev (>= 1.43.0~),
 libuv1-dev:native,
 node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
 node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>,
 openssl (>= 1.1.1~) <!nocheck>,
 pkg-config,
 pkg-js-tools (>= 0.8.2~) <!nocheck>,
 python3:native,
 python3-distutils,
 procps <!nocheck>,
 zlib1g-dev,
 zlib1g-dev:native,
Build-Depends-Indep:
 node-js-yaml (>= 4.1.0+dfsg+~4.0.5-6) <!nodoc>,
 node-marked (>= 4~) <!nodoc>,
 node-highlight.js <!nodoc>,
Standards-Version: 4.6.1.0
Homepage: https://nodejs.org/
Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-16.x
Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-16.x
Rules-Requires-Root: no

Package: libnode-dev
Section: libdevel
Architecture: amd64 arm64 armel armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel powerpc ppc64 ppc64el riscv64 s390x
Depends: ${misc:Depends},
 libssl-dev (>= 1.1.1~),
 libuv1-dev (>= 1.33.0~),
 libnode108 (= ${binary:Version})
Breaks: nodejs-dev (<< 10.0.0~dfsg1-3)
Replaces: libv8-dev,
 nodejs-dev (<< 10.0.0~dfsg1-3)
Conflicts: libv8-dev (<= 3.14.5.8-11)
Provides: libv8-dev
Description: evented I/O for V8 javascript (development files)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package provides development headers for libnode108

Package: nodejs
Architecture: amd64 arm64 armel armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel powerpc ppc64 ppc64el riscv64 s390x
Multi-Arch: allowed
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 sse2-support [i386],
 armv6k-support [armel], vfpv2-support [armel],
 libnode108 (= ${binary:Version})
Recommends: ca-certificates,
 nodejs-doc
Suggests: npm
Replaces: nodejs-legacy
 , libnode72 (<< 13)
 , libnode83 (<< 16.13.2+really14.19.1~dfsg~)
Conflicts: nodejs-legacy
Breaks: node-typescript-types (<< 20210110~)
 , node-babel-runtime (<< 7)
 , libnode72 (<< 13)
 , libnode83 (<< 16.13.2+really14.19.1~dfsg~)
Provides: node-types-node (= ${types:Node})
Description: evented I/O for V8 javascript - runtime executable
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: libnode108
Section: libs
Architecture: amd64 arm64 armel armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel powerpc ppc64 ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends},
 sse2-support [i386],
 armv6k-support [armel], vfpv2-support [armel]
Breaks: node-modern-syslog (<< 1.1.4-2),
 libnode64 (<< 10.24.1~),
 libnode72 (<< 13)
Replaces: nodejs-legacy, libnode72, libnode83, libnode93
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime library
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package provides the dynamic library for Node.js.

Package: nodejs-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Recommends: nodejs
Depends: ${misc:Depends}
Replaces: nodejs (<< 6.11.2~dfsg-3)
Conflicts: nodejs (<< 6.11.2~dfsg-3)
Description: API documentation for Node.js, the javascript platform
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains API documentation for Node.js.

## nodejs 18.10.0+dfsg

=== debian/changelog ===
nodejs (18.10.0+dfsg-6) unstable; urgency=medium

  * Move builtins dependencies to libnode108 (Closes: #1021107).
  * Mark another flaky test for riscv64

 -- Jérémy Lal <kapouer@melix.org>  Mon, 10 Oct 2022 10:49:19 +0200

nodejs (18.10.0+dfsg-5) unstable; urgency=medium

  * Breaks: node-jest (<< 29~)

 -- Jérémy Lal <kapouer@melix.org>  Sun, 09 Oct 2022 17:42:53 +0200

nodejs (18.10.0+dfsg-4) unstable; urgency=medium

  * Backport armel test failure fix
  * Allow undici-related test failures on riscv64 for now

 -- Jérémy Lal <kapouer@melix.org>  Sat, 01 Oct 2022 15:05:49 +0200

nodejs (18.10.0+dfsg-3) unstable; urgency=medium

  * Avoid depending on node to build node. Fix build.
  * Allow failure of another version of an already flaky test,
    seen to be failing on i386 - possibly on 32-bits architectures.

 -- Jérémy Lal <kapouer@melix.org>  Fri, 30 Sep 2022 01:23:56 +0200

nodejs (18.10.0+dfsg-2) unstable; urgency=medium

  * Revert /etc/default/nodejs and wrapper - env is enough
    Also avoids future bugs with node's process.execPath
  * Depends on externalized builtins (Closes: #1020980)

 -- Jérémy Lal <kapouer@melix.org>  Thu, 29 Sep 2022 23:55:15 +0200

nodejs (18.10.0+dfsg-1) unstable; urgency=medium

  [ Yadd ]
  * Drop /usr/lib/nodejs support

  [ Jérémy Lal ]
  * New upstream version 18.10.0+dfsg
  * Configurable builtins paths:
    + upstream patch implementing it
    + augment upstream patch to support acorn, acorn-walk
    + configure flags for acorn, undici, cjs-module-lexer
    + use pkgjs-ln for system-installed modules
    + exclude acorn, undici, cjs-module-lexer,
      they are all distributed and built in their own package
  * Allow custom flags to be set in /etc/defaults/nodejs
  * Patch openssl.conf used for tests to allow smoil keys,
    and disable some failing tests while waiting for upstream
    to upgrade their test keys. (Closes: #1020592)
  * Use shared ngtcp2, nghttp3
  * doc-generator:
    + fix node_modules setup using pkgjs-ln
    + update type-parser.mjs

 -- Jérémy Lal <kapouer@melix.org>  Thu, 29 Sep 2022 11:50:59 +0200

nodejs (18.8.0+dfsg-1) experimental; urgency=medium

  * New upstream version 18.8.0+dfsg
  * Drop patches applied upstream

 -- Jérémy Lal <kapouer@melix.org>  Sat, 03 Sep 2022 16:53:05 +0200

=== debian/control ===
--- 
+++ 
@@ -25,11 +25,16 @@
  libkvm-dev [kfreebsd-any],
  libnghttp2-dev (>= 1.41.0~),
  libnghttp2-dev:native,
+ libnghttp3-dev (>= 0.7.0~),
+ libnghttp3-dev:native,
+ libngtcp2-dev (>= 0.8.0~),
+ libngtcp2-dev:native,
  libssl-dev (>= 1.1.1~),
  libssl-dev:native,
  libuv1-dev (>= 1.43.0~),
  libuv1-dev:native,
  node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
+ node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
  node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>,
  openssl (>= 1.1.1~) <!nocheck>,
  pkg-config,
@@ -88,6 +93,7 @@
 Conflicts: nodejs-legacy
 Breaks: node-typescript-types (<< 20210110~)
  , node-babel-runtime (<< 7)
+ , node-jest (<< 29~)
  , libnode72 (<< 13)
  , libnode83 (<< 16.13.2+really14.19.1~dfsg~)
 Provides: node-types-node (= ${types:Node})
@@ -111,7 +117,10 @@
 Depends: ${shlibs:Depends},
  ${misc:Depends},
  sse2-support [i386],
- armv6k-support [armel], vfpv2-support [armel]
+ armv6k-support [armel], vfpv2-support [armel],
+ node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
+ node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
+ node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>
 Breaks: node-modern-syslog (<< 1.1.4-2),
  libnode64 (<< 10.24.1~),
  libnode72 (<< 13)

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildtools.mk

export CC = gcc-11
export CXX = g++-11

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

builtins := /usr/share/nodejs/node

# source equivalent of nodejs -e 'console.log(process.versions.modules)'
ABI = $(shell awk '/^#define NODE_MODULE_VERSION/ {print $$3}' src/node_version.h)

# archs
ARCHS := amd64 arm64 armel armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el riscv64 s390x

# branch
BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))

LANG=C
export LANG
DEB_CONFIGURE_NORMAL_ARGS =
DEB_CONFIGURE_EXTRA_FLAGS = \
--verbose \
--without-npm \
--without-corepack \
--shared \
--shared-zlib \
--shared-cares \
--shared-nghttp2 \
--shared-nghttp3 \
--shared-ngtcp2 \
--shared-brotli \
--shared-builtin-undici/undici-path=/usr/share/nodejs/undici/undici-fetch.js \
--shared-builtin-acorn-path=/usr/share/nodejs/acorn/dist/acorn.js \
--shared-builtin-acorn_walk-path=/usr/share/nodejs/acorn-walk/dist/walk.js \
--shared-builtin-cjs_module_lexer/lexer-path=/usr/share/nodejs/cjs-module-lexer/lexer.js \
--shared-builtin-cjs_module_lexer/dist/lexer-path=/usr/share/nodejs/cjs-module-lexer/dist/lexer.js \
--with-intl=system-icu \
--prefix=/usr \
--shared-openssl \
--openssl-use-def-ca-store \
--arch-triplet=$(DEB_HOST_MULTIARCH) \
--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs" \
--shared-libuv

ifneq ($(filter pkg.nodejs.nobuiltin,$(DEB_BUILD_PROFILES)),)
	DEB_CONFIGURE_EXTRA_FLAGS += --node-builtin-modules-path=$(builtins)
endif

# map HOST ARCH AND OS, and if unknown let upstream guess

destCpu =
destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter x32,$(DEB_HOST_ARCH)),x32))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter hurd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter armel,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter armhf,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter aarch64,$(DEB_HOST_ARCH)),arm64))
destCpu := $(or $(destCpu),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mipsel))
destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips64r6el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),ppc))
destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
destCpu := $(or $(destCpu),$(if $(filter riscv64,$(DEB_HOST_ARCH)),riscv64))
destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))

# solaris freebsd openbsd linux
destOs =
destOs := $(or $(destOs),$(if $(filter linux,$(DEB_HOST_ARCH_OS)),linux))
destOs := $(or $(destOs),$(if $(filter kfreebsd,$(DEB_HOST_ARCH_OS)),freebsd))

ifneq (, $(destOs))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-os=$(destOs)
endif
ifeq (unsupported, $(destCpu))
$(error "nodejs cannot run on $(DEB_HOST_ARCH), please consult maintainers")
endif
ifneq (, $(destCpu))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
endif

ifeq (freebsd, $(destOs))
LDFLAGS += -lbsd
endif

# mips and fpu
# https://github.com/paul99/v8m-rb/issues/192
# https://bugs.debian.org/800410
# mips and big binaries
# http://gcc.gnu.org/wiki/DebugFission
# https://bugs.debian.org/829139

# use r2, which is the supported variant for these architectures
# https://lists.debian.org/debian-mips/2016/07/msg00000.html
ifeq (mipsel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

# mips32r1 or greater, detected at runtime
ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips64r6el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

ifeq (armel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=softfp
ifeq ($(shell dpkg-vendor --is ubuntu && echo true),true)
# Ubuntu targets armv7+ with VFP and thumb2 support by default for armel
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
else
# debian armel version
# v8 supports armv6k (must be set explicitely) + vfpv2 (selected by default)
# armv6k is only not available on ARM1136JF-S r0p2, and available on r1p0.
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv2 --with-arm-version=6
CFLAGS += -march=armv6k -mfpu=vfpv2
CPPFLAGS += -march=armv6k -mfpu=vfpv2
endif
endif

ifeq (armhf, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
# enable vfp, disable armv7
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
else
# enable armv7 vfpv3
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
endif
endif

DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean
DEB_MAKE_BUILD_TARGET = build

#  relax regression tests when targeted experimental suite
export HOME = $(CURDIR)/tmp
export FLAKY_TESTS = dontcare
export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
export CI_JS_SUITES = message parallel sequential
export NODE_TEST_DIR = $(CURDIR)/tmp
export NODE_TEST_NO_INTERNET = 1
# needed for tests to avoid "ee key too small" errors
export OPENSSL_CONF = $(CURDIR)/deps/openssl/openssl/apps/openssl.cnf
# keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js

# build -fPIC
CFLAGS += -fPIC
CPPFLAGS += -fPIC

ifeq ($(DEB_HOST_ARCH_BITS),32)
CFLAGS += -g1
CPPFLAGS += -g1
DH_FLAGS += --max-parallel=1
export JOBS = 1
else
CFLAGS += -g
CPPFLAGS += -g
endif


# hardening gyp
CXXFLAGS += $(CPPFLAGS)

export CPPFLAGS
export CXXFLAGS
export CFLAGS
export LDFLAGS

export PYTHON = python3

%:
	dh $@ --with bash-completion $(DH_FLAGS)

# properly clean files from build, test, python
override_dh_auto_clean:
	dh_auto_clean
	rm -f node_trace.1.log
	rm -f icu_config.gypi
	rm -rf test/addons/doc-*
	rm -f test/addons/.buildstamp
	rm -f test/addons/.docbuildstamp
	rm -rf test/addons/*/build
	rm -f config.gypi
	rm -f config.mk
	rm -f config.status
	rm -f test/fixtures/hello.txt
	rm -rf $(NODE_TEST_DIR)
	find . -name "*.pyc" -delete
	rm -rf out
	rm -rf node_modules
	rm -f debian/libnode$(ABI).install
	rm -f debian/libnode-dev.links
	rm -f debian/nodejs.install
	rm -f debian/nodejs.bash-completion

# remove *.json files from documentation
override_dh_installdocs:
	dh_installdocs
	find debian/nodejs-doc/usr/share/doc/nodejs-doc -name *.json -delete || true

override_dh_auto_configure:
# gyp    | debian
# -------+-------
# target | host
# host   | build

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	CC=$(CC) CXX=$(CXX) PKG_CONFIG=$(PKG_CONFIG) CC_host=$(CC_FOR_BUILD) CXX_host=$(CXX_FOR_BUILD) ./configure --cross-compiling $(DEB_CONFIGURE_EXTRA_FLAGS)
else
	./configure $(DEB_CONFIGURE_EXTRA_FLAGS)
endif

override_dh_auto_build-arch:
	dh_auto_build
	./out/Release/node --completion-bash > ./debian/nodejs.bash-completion

override_dh_auto_build-indep:
	mkdir -p node_modules
	ln -sf /usr/share/nodejs/marked node_modules/
	ln -sf /usr/share/nodejs/acorn node_modules/
	ln -sf /usr/share/nodejs/js-yaml node_modules/

=== debian/watch ===
version=4
opts=downloadurlmangle=s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.xz/,\
dversionmangle=auto,\
repacksuffix=+dfsg \
https://nodejs.org/dist v(\d+\.\d+\.\d+)/ group

# It is not recommended use npmregistry. Please investigate more.
# Take a look at https://wiki.debian.org/debian/watch/
opts="searchmode=plain,ctype=nodejs,component=types-node,pgpmode=none" \
 https://registry.npmjs.org/@types/node https://registry.npmjs.org/@types/node/-/node-(\d+[\d\.]+)@ARCHIVE_EXT@ ignore

## nodejs 18.12.1+dfsg

=== debian/changelog ===
nodejs (18.12.1+dfsg-2) unstable; urgency=medium

  * Patch: fix test suite for icu 72.1

 -- Jérémy Lal <kapouer@melix.org>  Wed, 09 Nov 2022 18:16:06 +0100

nodejs (18.12.1+dfsg-1) unstable; urgency=medium

  * New upstream version 18.12.1+dfsg
  * Fixes CVE-2022-43548: DNS rebinding in --inspect via invalid
    octal IP address (Medium).
    Closes: #1023518.
  * Build using gcc-11, g++-11, fixes mips64el and riscv64 builds,
    https://github.com/nodejs/node/issues/44126
  * Patch: fix link to home in html doc. Closes: #1018153

 -- Jérémy Lal <kapouer@melix.org>  Sun, 06 Nov 2022 00:14:11 +0100

nodejs (18.12.0+dfsg-1) unstable; urgency=medium

  * New upstream version 18.12.0+dfsg
  * Add flaky new debugger test
  * watch nodejs 18 LTS

 -- Jérémy Lal <kapouer@melix.org>  Thu, 27 Oct 2022 15:02:24 +0200

nodejs (18.11.0+dfsg-4) experimental; urgency=medium

  * Patch: fix mipsel build failure
  * Patch: drop mips/no_jitless, fixed upstream

 -- Jérémy Lal <kapouer@melix.org>  Wed, 26 Oct 2022 01:23:22 +0200

nodejs (18.11.0+dfsg-3) experimental; urgency=medium

  * Revert "Build using gcc-11, g++-11"
  * Skip buggy watch mode tests

 -- Jérémy Lal <kapouer@melix.org>  Mon, 17 Oct 2022 14:04:02 +0200

nodejs (18.11.0+dfsg-2) experimental; urgency=medium

  * Do not use --shared-ngctp2/http3 switch

 -- Jérémy Lal <kapouer@melix.org>  Fri, 14 Oct 2022 16:23:40 +0200

nodejs (18.11.0+dfsg-1) experimental; urgency=medium

  * New upstream version 18.11.0+dfsg
  * armhf: minimal target is vfpv3-d16 (Closes: #1021546).
  * copyright: update for a new file
  * Drop nghttp3, ngtcp2 deps: useless without openssl-quic
  * Refresh patches

 -- Jérémy Lal <kapouer@melix.org>  Fri, 14 Oct 2022 15:30:25 +0200

## nodejs 18.13.0%2Bdfsg1

=== debian/changelog ===
nodejs (18.13.0+dfsg1-1+rpi1) bookworm-staging; urgency=medium

  [changes brought forward from 18.10.0+dfsg-6+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Tue, 15 Nov 2022 03:51:54 +0000]
  * Set --with-arm-version=6 on raspbian.
  * Use armv6k CFLAGS on raspbian.
  * Disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Tue, 17 Jan 2023 00:44:29 +0000

nodejs (18.13.0+dfsg1-1) unstable; urgency=medium

  [ Bo YU ]
  * Fix FTBFS on riscv64. Closes: 1028404

  [ Jérémy Lal ]
  * doc-generator: update types
  * copyright: deps/v8/third_party/ittapi
  * copyright: Files-Excluded snapshot.blob, new orig tarball

 -- Jérémy Lal <kapouer@melix.org>  Wed, 11 Jan 2023 17:42:19 +0100

nodejs (18.13.0+dfsg-1) unstable; urgency=medium

  * New upstream version 18.13.0+dfsg
  * Drop applied patches
  * Add tracing, crypto headers to /usr/include/nodejs
  * riscv64: mark flaky tests. Closes: 1026065
  * copyright: remove uv/android* files
  * Drop n/a lintian overrides for zlib
  * lintian-overrides: update false source-is-missing

 -- Jérémy Lal <kapouer@melix.org>  Fri, 06 Jan 2023 21:15:20 +0100

=== debian/control ===
--- 
+++ 
@@ -25,10 +25,6 @@
  libkvm-dev [kfreebsd-any],
  libnghttp2-dev (>= 1.41.0~),
  libnghttp2-dev:native,
- libnghttp3-dev (>= 0.7.0~),
- libnghttp3-dev:native,
- libngtcp2-dev (>= 0.8.0~),
- libngtcp2-dev:native,
  libssl-dev (>= 1.1.1~),
  libssl-dev:native,
  libuv1-dev (>= 1.43.0~),

=== debian/rules ===
--- 
+++ 
@@ -31,8 +31,6 @@
 --shared-zlib \
 --shared-cares \
 --shared-nghttp2 \
---shared-nghttp3 \
---shared-ngtcp2 \
 --shared-brotli \
 --shared-builtin-undici/undici-path=/usr/share/nodejs/undici/undici-fetch.js \
 --shared-builtin-acorn-path=/usr/share/nodejs/acorn/dist/acorn.js \
@@ -142,10 +140,12 @@
 DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
 ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
 # enable vfp, disable armv7
-DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
-else
-# enable armv7 vfpv3
-DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
+DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp --with-arm-version=6
+CFLAGS += -march=armv6k -mfpu=vfpv2
+CPPFLAGS += -march=armv6k -mfpu=vfpv2
+else
+# enable armv7 vfpv3-d16
+DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3-d16
 endif
 endif
 
@@ -240,5 +240,3 @@
 override_dh_auto_build-indep:
 	mkdir -p node_modules
 	ln -sf /usr/share/nodejs/marked node_modules/
-	ln -sf /usr/share/nodejs/acorn node_modules/
-	ln -sf /usr/share/nodejs/js-yaml node_modules/

=== debian/watch ===
version=4
opts=downloadurlmangle=s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.xz/,\
dversionmangle=auto,\
repacksuffix=+dfsg \
https://nodejs.org/dist v(18\.\d+\.\d+)/ group

# It is not recommended use npmregistry. Please investigate more.
# Take a look at https://wiki.debian.org/debian/watch/
opts="searchmode=plain,ctype=nodejs,component=types-node,pgpmode=none" \
 https://registry.npmjs.org/@types/node https://registry.npmjs.org/@types/node/-/node-(18[\d\.]+)@ARCHIVE_EXT@ ignore

## nodejs 18.13.0+dfsg

=== Makefile ===
-include config.mk

BUILDTYPE ?= Release
PYTHON ?= python3
DESTDIR ?=
SIGN ?=
PREFIX ?= /usr/local
FLAKY_TESTS ?= run
TEST_CI_ARGS ?=
STAGINGSERVER ?= node-www
LOGLEVEL ?= silent
OSTYPE := $(shell uname -s | tr '[:upper:]' '[:lower:]')
ifeq ($(findstring os/390,$OSTYPE),os/390)
OSTYPE ?= os390
endif
ARCHTYPE := $(shell uname -m | tr '[:upper:]' '[:lower:]')
COVTESTS ?= test-cov
COV_SKIP_TESTS ?= core_line_numbers.js,testFinalizer.js,test_function/test.js
GTEST_FILTER ?= "*"
GNUMAKEFLAGS += --no-print-directory
GCOV ?= gcov
PWD = $(CURDIR)
BUILD_WITH ?= make
FIND ?= find

ifdef JOBS
	PARALLEL_ARGS = -j $(JOBS)
else
	PARALLEL_ARGS =
endif

ifdef ENABLE_V8_TAP
	TAP_V8 := --junitout $(PWD)/v8-tap.xml
	TAP_V8_INTL := --junitout $(PWD)/v8-intl-tap.xml
	TAP_V8_BENCHMARKS := --junitout $(PWD)/v8-benchmarks-tap.xml
define convert_to_junit
	@true
endef
endif

ifdef ENABLE_CONVERT_V8_JSON_TO_XML
	TAP_V8_JSON := $(PWD)/v8-tap.json
	TAP_V8_INTL_JSON := $(PWD)/v8-intl-tap.json
	TAP_V8_BENCHMARKS_JSON := $(PWD)/v8-benchmarks-tap.json

	# By default, the V8's JSON test output only includes the tests which have
	# failed. We use --slow-tests-cutoff to ensure that all tests are present
	# in the output, including those which pass.
	TAP_V8 := --json-test-results $(TAP_V8_JSON) --slow-tests-cutoff 1000000
	TAP_V8_INTL := --json-test-results $(TAP_V8_INTL_JSON) --slow-tests-cutoff 1000000
	TAP_V8_BENCHMARKS := --json-test-results $(TAP_V8_BENCHMARKS_JSON) --slow-tests-cutoff 1000000

define convert_to_junit
	export PATH="$(NO_BIN_OVERRIDE_PATH)" && \
		$(PYTHON) tools/v8-json-to-junit.py < $(1) > $(1:.json=.xml)
endef
endif

V8_TEST_OPTIONS = $(V8_EXTRA_TEST_OPTIONS)
ifdef DISABLE_V8_I18N
	V8_BUILD_OPTIONS += i18nsupport=off
endif
# V8 build and test toolchains are not currently compatible with Python 3.
# config.mk may have prepended a symlink for `python` to PATH which we need
# to undo before calling V8's tools.
OVERRIDE_BIN_DIR=$(dir $(abspath $(lastword $(MAKEFILE_LIST))))out/tools/bin
NO_BIN_OVERRIDE_PATH=$(subst $() $(),:,$(filter-out $(OVERRIDE_BIN_DIR),$(subst :, ,$(PATH))))

ifeq ($(OSTYPE), darwin)
	GCOV = xcrun llvm-cov gcov
endif

BUILDTYPE_LOWER := $(shell echo $(BUILDTYPE) | tr '[:upper:]' '[:lower:]')

# Determine EXEEXT
EXEEXT := $(shell $(PYTHON) -c \
		"import sys; print('.exe' if sys.platform == 'win32' else '')")

NODE_EXE = node$(EXEEXT)
NODE ?= ./$(NODE_EXE)
NODE_G_EXE = node_g$(EXEEXT)
NPM ?= ./deps/npm/bin/npm-cli.js

# Flags for packaging.
BUILD_DOWNLOAD_FLAGS ?= --download=all
BUILD_INTL_FLAGS ?= --with-intl=full-icu
BUILD_RELEASE_FLAGS ?= $(BUILD_DOWNLOAD_FLAGS) $(BUILD_INTL_FLAGS)

# Default to quiet/pretty builds.
# To do verbose builds, run `make V=1` or set the V environment variable.
V ?= 0

# Use -e to double check in case it's a broken link
# Use $(PWD) so we can cd to anywhere before calling this
available-node = \
	if [ -x $(PWD)/$(NODE) ] && [ -e $(PWD)/$(NODE) ]; then \
		$(PWD)/$(NODE) $(1); \
	elif [ -x `command -v node` ] && [ -e `command -v node` ] && [ `command -v node` ]; then \
		`command -v node` $(1); \
	else \
		echo "No available node, cannot run \"node $(1)\""; \
		exit 1; \
	fi;

.PHONY: all
# BUILDTYPE=Debug builds both release and debug builds. If you want to compile
# just the debug build, run `make -C out BUILDTYPE=Debug` instead.
ifeq ($(BUILDTYPE),Release)
all: $(NODE_EXE) ## Default target, builds node in out/Release/node.
else
all: $(NODE_EXE) $(NODE_G_EXE)
endif

.PHONY: help
# To add a target to the help, add a double comment (##) on the target line.
help: ## Print help for targets with comments.
	@printf "For more targets and info see the comments in the Makefile.\n\n"
	@grep -E '^[[:alnum:]._-]+:.*?## .*$$' Makefile | sort | \
		awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-15s\033[0m %s\n", $$1, $$2}'

# The .PHONY is needed to ensure that we recursively use the out/Makefile
# to check for changes.
.PHONY: $(NODE_EXE) $(NODE_G_EXE)

# The -r/-L check stops it recreating the link if it is already in place,
# otherwise $(NODE_EXE) being a .PHONY target means it is always re-run.
# Without the check there is a race condition between the link being deleted
# and recreated which can break the addons build when running test-ci
# See comments on the build-addons target for some more info
ifeq ($(BUILD_WITH), make)
$(NODE_EXE): build_type:=Release
$(NODE_G_EXE): build_type:=Debug
$(NODE_EXE) $(NODE_G_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=${build_type} V=$(V)
	if [ ! -r $@ ] || [ ! -L $@ ]; then \
	  ln -fs out/${build_type}/$(NODE_EXE) $@; fi
else
ifeq ($(BUILD_WITH), ninja)
NINJA ?= ninja
ifeq ($(V),1)
	NINJA_ARGS := $(NINJA_ARGS) -v
endif
ifdef JOBS
	NINJA_ARGS := $(NINJA_ARGS) -j$(JOBS)
else
	NINJA_ARGS := $(NINJA_ARGS) $(filter -j%,$(MAKEFLAGS))
endif
$(NODE_EXE): config.gypi out/Release/build.ninja
	$(NINJA) -C out/Release $(NINJA_ARGS)
	if [ ! -r $@ ] || [ ! -L $@ ]; then ln -fs out/Release/$(NODE_EXE) $@; fi

$(NODE_G_EXE): config.gypi out/Debug/build.ninja
	$(NINJA) -C out/Debug $(NINJA_ARGS)
	if [ ! -r $@ ] || [ ! -L $@ ]; then ln -fs out/Debug/$(NODE_EXE) $@; fi
else
$(NODE_EXE) $(NODE_G_EXE):
	$(warning This Makefile currently only supports building with 'make' or 'ninja')
endif
endif


ifeq ($(BUILDTYPE),Debug)
CONFIG_FLAGS += --debug
endif

.PHONY: with-code-cache
.PHONY: test-code-cache
with-code-cache test-code-cache:
	$(warning '$@' target is a noop)

out/Makefile: config.gypi common.gypi node.gyp \
	deps/uv/uv.gyp deps/llhttp/llhttp.gyp deps/zlib/zlib.gyp \
	tools/v8_gypfiles/toolchain.gypi tools/v8_gypfiles/features.gypi \
	tools/v8_gypfiles/inspector.gypi tools/v8_gypfiles/v8.gyp
	$(PYTHON) tools/gyp_node.py -f make

# node_version.h is listed because the N-API version is taken from there
# and included in config.gypi
config.gypi: configure configure.py src/node_version.h
	@if [ -x config.status ]; then \
		export PATH="$(NO_BIN_OVERRIDE_PATH)" && ./config.status; \
	else \
		echo Missing or stale $@, please run ./$<; \
		exit 1; \
	fi

.PHONY: install
install: all ## Installs node into $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

.PHONY: uninstall
uninstall: ## Uninstalls node from $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

.PHONY: clean
.NOTPARALLEL: clean
clean: ## Remove build artifacts.
	$(RM) -r out/Makefile $(NODE_EXE) $(NODE_G_EXE) out/$(BUILDTYPE)/$(NODE_EXE) \
		out/$(BUILDTYPE)/node.exp
	@if [ -d out ]; then $(FIND) out/ -name '*.o' -o -name '*.a' -o -name '*.d' | xargs $(RM) -r; fi
	$(RM) -r node_modules
	@if [ -d deps/icu ]; then echo deleting deps/icu; $(RM) -r deps/icu; fi
	$(RM) test.tap
	$(MAKE) testclean
	$(MAKE) test-addons-clean
	$(MAKE) bench-addons-clean

.PHONY: testclean
.NOTPARALLEL: testclean
testclean:
# Next one is legacy remove this at some point
	$(RM) -r test/tmp*
	$(RM) -r test/.tmp*

.PHONY: distclean
.NOTPARALLEL: distclean
distclean:
	$(RM) -r out
	$(RM) config.gypi icu_config.gypi
	$(RM) config.mk
	$(RM) -r $(NODE_EXE) $(NODE_G_EXE)
	$(RM) -r node_modules
	$(RM) -r deps/icu
	$(RM) -r deps/icu4c*.tgz deps/icu4c*.zip deps/icu-tmp
	$(RM) $(BINARYTAR).* $(TARBALL).*

.PHONY: check
check: test

.PHONY: coverage-clean
.NOTPARALLEL: coverage-clean
# Remove files generated by running coverage, put the non-instrumented lib back
# in place
coverage-clean:
	$(RM) -r node_modules
	$(RM) -r gcovr
	$(RM) -r coverage/tmp
	$(FIND) out/$(BUILDTYPE)/obj.target \( -name "*.gcda" -o -name "*.gcno" \) \
		-type f -exec $(RM) {} \;

.PHONY: coverage
# Build and test with code coverage reporting. HTML coverage reports will be
# created under coverage/. For C++ coverage reporting, this needs to be run
# in conjunction with configure --coverage.
# Related CI job: node-test-commit-linux-coverage-daily
coverage: coverage-test ## Run the tests and generate a coverage report.

.PHONY: coverage-build
coverage-build: all
	-$(MAKE) coverage-build-js
	if [ ! -d gcovr ]; then $(PYTHON) -m pip install -t gcovr gcovr==4.2; fi
	$(MAKE)

.PHONY: coverage-build-js
coverage-build-js:
	mkdir -p node_modules
	if [ ! -d node_modules/c8 ]; then \
		$(NODE) ./deps/npm install c8 --no-save --no-package-lock;\
	fi

.PHONY: coverage-test
coverage-test: coverage-build
	$(FIND) out/$(BUILDTYPE)/obj.target -name "*.gcda" -type f -exec $(RM) {} \;
	-NODE_V8_COVERAGE=coverage/tmp \
		TEST_CI_ARGS="$(TEST_CI_ARGS) --type=coverage" $(MAKE) $(COVTESTS)
	$(MAKE) coverage-report-js
	-(cd out && PYTHONPATH=../gcovr $(PYTHON) -m gcovr \
		--gcov-exclude='.*\b(deps|usr|out|cctest|embedding)\b' -v \
		-r ../src/ --object-directory Release/obj.target \
		--html --html-details -o ../coverage/cxxcoverage.html \
		--gcov-executable="$(GCOV)")
	@printf "Javascript coverage %%: "
	@grep -B1 Lines coverage/index.html | head -n1 \
		| sed 's/<[^>]*>//g'| sed 's/ //g'
	@printf "C++ coverage %%: "
	@grep -A3 Lines coverage/cxxcoverage.html | grep style  \
		| sed 's/<[^>]*>//g'| sed 's/ //g'

.PHONY: coverage-report-js
coverage-report-js:
	-$(MAKE) coverage-build-js
	$(NODE) ./node_modules/.bin/c8 report

.PHONY: cctest
# Runs the C++ tests using the built `cctest` executable.
cctest: all
	@out/$(BUILDTYPE)/$@ --gtest_filter=$(GTEST_FILTER)
	@out/$(BUILDTYPE)/embedtest "require('./test/embedding/test-embedding.js')"

.PHONY: list-gtests
list-gtests:
ifeq (,$(wildcard out/$(BUILDTYPE)/cctest))
	$(error Please run 'make cctest' first)
endif
	@out/$(BUILDTYPE)/cctest --gtest_list_tests

.PHONY: v8
# Related CI job: node-test-commit-v8-linux
# Rebuilds deps/v8 as a git tree, pulls its third-party dependencies, and
# builds it.
v8:
	export PATH="$(NO_BIN_OVERRIDE_PATH)" && \
		tools/make-v8.sh $(V8_ARCH).$(BUILDTYPE_LOWER) $(V8_BUILD_OPTIONS)

.PHONY: jstest
jstest: build-addons build-js-native-api-tests build-node-api-tests ## Runs addon tests and JS tests
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) \
		$(TEST_CI_ARGS) \
		--skip-tests=$(CI_SKIP_TESTS) \
		$(JS_SUITES) \
		$(NATIVE_SUITES)

.PHONY: tooltest
tooltest:
	@$(PYTHON) -m unittest discover -s ./test/tools

.PHONY: coverage-run-js
coverage-run-js:
	$(RM) -r coverage/tmp
	-NODE_V8_COVERAGE=coverage/tmp CI_SKIP_TESTS=$(COV_SKIP_TESTS) \
					TEST_CI_ARGS="$(TEST_CI_ARGS) --type=coverage" $(MAKE) jstest
	$(MAKE) coverage-report-js

.PHONY: test
# This does not run tests of third-party libraries inside deps.
test: all ## Runs default tests, linters, and builds docs.
	$(MAKE) -s tooltest
	$(MAKE) -s test-doc
	$(MAKE) -s build-addons
	$(MAKE) -s build-js-native-api-tests
	$(MAKE) -s build-node-api-tests
	$(MAKE) -s cctest
	$(MAKE) -s jstest

.PHONY: test-only
test-only: all  ## For a quick test, does not run linter or build docs.
	$(MAKE) build-addons
	$(MAKE) build-js-native-api-tests
	$(MAKE) build-node-api-tests
	$(MAKE) cctest
	$(MAKE) jstest
	$(MAKE) tooltest

# Used by `make coverage-test`
.PHONY: test-cov
test-cov: all
	$(MAKE) build-addons
	$(MAKE) build-js-native-api-tests
	$(MAKE) build-node-api-tests
	$(MAKE) cctest
	CI_SKIP_TESTS=$(COV_SKIP_TESTS) $(MAKE) jstest

.PHONY: test-parallel
test-parallel: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) parallel

.PHONY: test-valgrind
test-valgrind: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --valgrind sequential parallel message

.PHONY: test-check-deopts
test-check-deopts: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --check-deopts parallel sequential

DOCBUILDSTAMP_PREREQS = tools/doc/addon-verify.mjs doc/api/addons.md

ifeq ($(OSTYPE),aix)
DOCBUILDSTAMP_PREREQS := $(DOCBUILDSTAMP_PREREQS) out/$(BUILDTYPE)/node.exp
endif

node_use_openssl = $(call available-node,"-p" \
			 "process.versions.openssl != undefined")
test/addons/.docbuildstamp: $(DOCBUILDSTAMP_PREREQS) tools/doc/node_modules
	@if [ "$(shell $(node_use_openssl))" != "true" ]; then \
		echo "Skipping .docbuildstamp (no crypto)"; \
	else \
		$(RM) -r test/addons/??_*/; \

=== debian/rules ===
--- 
+++ 
@@ -140,9 +140,7 @@
 DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
 ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
 # enable vfp, disable armv7
-DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp --with-arm-version=6
-CFLAGS += -march=armv6k -mfpu=vfpv2
-CPPFLAGS += -march=armv6k -mfpu=vfpv2
+DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
 else
 # enable armv7 vfpv3-d16
 DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3-d16
@@ -240,3 +238,7 @@
 override_dh_auto_build-indep:
 	mkdir -p node_modules
 	ln -sf /usr/share/nodejs/marked node_modules/
+	ln -sf /usr/share/nodejs/acorn node_modules/
+	ln -sf /usr/share/nodejs/js-yaml node_modules/
+	$(MAKE) doc-only
+

## nodejs 18.13.0+dfsg1

=== debian/changelog ===
nodejs (18.13.0+dfsg1-1ubuntu2) lunar; urgency=medium

  * Rebuild against latest icu

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 26 Feb 2023 13:51:50 -0500

nodejs (18.13.0+dfsg1-1ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Use gold linker on arm64 to fix a link failure
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Fix offset by one in one new test

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 03 Feb 2023 23:40:23 +0100

nodejs (18.13.0+dfsg-1ubuntu3) lunar; urgency=medium

  [ Bo YU ]
  * Fix ftbfs on riscv64. (Closes: #1028404)

  [ Gianfranco Costamagna ]
  * Cherry-pick patch from Bug to Ubuntu

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 11 Jan 2023 08:34:37 +0100

nodejs (18.13.0+dfsg-1ubuntu2) lunar; urgency=medium

  * Fix offset by one in one new test

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 09 Jan 2023 15:39:45 +0100

nodejs (18.13.0+dfsg-1ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Use gold linker on arm64 to fix a link failure
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 07 Jan 2023 19:36:56 +0100

nodejs (18.7.0+dfsg-5ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 02 Sep 2022 11:43:37 +0200

nodejs (18.7.0+dfsg-4ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 01 Sep 2022 09:30:03 +0200

nodejs (18.7.0+dfsg-1ubuntu2) kinetic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 24 Aug 2022 19:52:36 +0200

=== debian/rules ===
--- 
+++ 
@@ -85,6 +85,10 @@
 DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
 endif
 
+ifeq (arm64, $(DEB_HOST_ARCH))
+LDFLAGS += -Wl,-fuse-ld=gold
+endif
+
 ifeq (freebsd, $(destOs))
 LDFLAGS += -lbsd
 endif
@@ -154,7 +158,7 @@
 #  relax regression tests when targeted experimental suite
 export HOME = $(CURDIR)/tmp
 export FLAKY_TESTS = dontcare
-export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
+export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000 --node-args="--openssl-shared-config"
 export CI_JS_SUITES = message parallel sequential
 export NODE_TEST_DIR = $(CURDIR)/tmp
 export NODE_TEST_NO_INTERNET = 1
@@ -238,7 +242,3 @@
 override_dh_auto_build-indep:
 	mkdir -p node_modules
 	ln -sf /usr/share/nodejs/marked node_modules/
-	ln -sf /usr/share/nodejs/acorn node_modules/
-	ln -sf /usr/share/nodejs/js-yaml node_modules/
-	$(MAKE) doc-only
-
